/*
 *  CoreAudioDataLine.h
 *  CoreAudioJavaSoundLib
 *
 *  Created by Klaus Jänsch on 31.01.12.
 *  Copyright 2012 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef COREAUDIODATALINE_H_
#define COREAUDIODATALINE_H_

#include <CoreFoundation/CoreFoundation.h>
//#include <CoreAudio/CoreAudioTypes.h>
#include <CoreAudio/AudioHardware.h>
#include <CoreAudio/CoreAudio.h>
#include <JavaVM/jni.h>
extern "C" {
	typedef struct dls {
		AudioDeviceID deviceID;
		AudioStreamID streamID;
		AudioDeviceIOProcID ioProcId;
		jboolean isPlayback;
		jint bufferSize;
		AudioStreamBasicDescription pFormat;
		jint  sampleSizeInBytes;
		jbyte* buffer;
		volatile jlong writePos;
		volatile jlong readPos;
		volatile jboolean running;
		volatile jboolean drain;
		volatile jboolean drained;
		} dataline;
	
	
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_enumerateFormats(JNIEnv *, jobject,jobject);
	JNIEXPORT jboolean JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_start(JNIEnv *, jobject,jobject);
	JNIEXPORT jobject JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_open(JNIEnv *, jobject,jobject,jfloat,jint,jint,jint);
	JNIEXPORT jboolean JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_stop(JNIEnv *env, jobject obj,jobject);
	JNIEXPORT jint JNICALL Java_ips_audio_coreaudio_CoreAudioTargetDataLine_coreAudioBytesAvailable(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT jint JNICALL Java_ips_audio_coreaudio_CoreAudioSourceDataLine_coreAudioBytesAvailable(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioSourceDataLine_drain(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT jboolean JNICALL Java_ips_audio_coreaudio_CoreAudioSourceDataLine_drained(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT jlong JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_getWritePos(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT jlong JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_getReadPos(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioTargetDataLine_addToReadPos(JNIEnv *env, jobject obj,jobject jdl,jint read);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioSourceDataLine_addToWritePos(JNIEnv *env, jobject obj,jobject jdl,jint);
	JNIEXPORT jint JNICALL Java_ips_audio_coreaudio_CoreAudioTargetDataLine_read(JNIEnv *env, jobject obj,jobject,jbyteArray,jint offset,jint len);
	JNIEXPORT jboolean JNICALL Java_ips_audio_coreaudio_CoreAudioTargetDataLine_isRunning(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioTargetDataLine_flush(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioSourceDataLine_flush(JNIEnv *env, jobject obj,jobject jdl);
	JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioDataLine_close(JNIEnv *env, jobject obj,jobject jdl);
	
}

#endif